<script setup lang="ts">
  import { required, email, minLength } from '@vuelidate/validators';
  import { useVuelidate } from '@vuelidate/core';
  import { ClientApiError, CustomerRegistrationParams } from '@shopware-pwa/types';
  import { getTranslatedProperty } from '@shopware-pwa/helpers-next';
  import { getErrorMessages } from '~/helpers/errors';
  import { DAILY_PRIVACY_POLICY_LINK } from '~/helpers/constants';

  definePageMeta({
    layout: 'auth',
    middleware: ['presentation-pre-action'],
  });

  type FORM_STATE = {
    salutationId: string;
    firstName: string;
    lastName: string;
    email: string;
    password: string;
    street: string;
    zipcode: string;
    city: string;
    countryId: string | undefined;
    agree: boolean;
  };

  const localePath = useLocalePath();
  const { register, setCookieGuestAttendeeName, logout } = useUser();
  const nuxtApp = useNuxtApp();
  const router = useRouter();
  const route = useRoute();
  const { countryId } = useSessionContext();
  const { getVideoAndAudioSetting, mediaShouldBeUsed } = useAppointment();

  const isLoading = ref<boolean>();
  const registerErrorMsg = ref<string>();

  const { getSalutations } = useSalutations();
  const { getCountries } = useCountries();

  const salutations = computed(() => {
    if (!getSalutations.value?.length) return [];
    const mappedSalutations = getSalutations.value.map((salutation) => ({
      name: salutation.displayName ?? salutation.salutationKey,
      id: salutation.id,
    }));
    return mappedSalutations.filter((mappedSalutation) => mappedSalutation.name !== null);
  });

  const countries = computed(() => {
    if (!getCountries.value?.length) return [];

    const mappedCountries = getCountries.value.map((country) => ({
      name: getTranslatedProperty(country, 'name'),
      id: country.id,
    }));
    return mappedCountries.filter((country) => !!country.name);
  });

  // update dropdown
  watchOnce(getSalutations, (list) => {
    if (list) {
      state.salutationId = list.find(
        (salutation) => salutation.salutationKey === 'not_specified',
      )!.id;
    }
  });

  watchOnce(getCountries, (list) => {
    if (list) {
      state.countryId = list.find((country) => country.id === countryId.value)?.id;
    }
  });

  const state = reactive<FORM_STATE>({
    salutationId: '',
    firstName: '',
    lastName: '',
    email: '',
    password: '',
    street: '',
    zipcode: '',
    city: '',
    countryId: '',
    agree: false,
  });

  const rules = {
    salutationId: {},
    firstName: {
      required,
    },
    lastName: {
      required,
    },
    email: {
      required,
      email,
    },
    password: {
      required,
      minLength: minLength(8),
    },
    street: {
      required,
    },
    zipcode: {
      required,
    },
    city: {
      required,
    },
    countryId: {
      required,
    },
    agree: {
      checked: (value: any) => {
        if (!mediaShouldBeUsed.value) {
          return true;
        } else {
          return value === true;
        }
      },
    },
  };

  const $v = useVuelidate(rules, state);

  onBeforeMount(async () => {
    nuxtApp.$setLoading(true);
    await removeSession();
    await getVideoAndAudioSetting();

    setTimeout(() => {
      nuxtApp.$setLoading(false);
    });
  });

  const removeSession = async () => {
    setCookieGuestAttendeeName('');
    try {
      await logout();
    } catch (e) {}
  };

  const createAndJoin = async (e: Event) => {
    e.preventDefault();
    $v.value.$touch();
    const valid = await $v.value.$validate();

    if (!valid) return;

    try {
      isLoading.value = true;

      const params: CustomerRegistrationParams = {
        firstName: state.firstName,
        lastName: state.lastName,
        email: state.email,
        password: state.password,
        salutationId: state.salutationId,
        billingAddress: {
          firstName: state.firstName,
          salutationId: state.salutationId,
          lastName: state.lastName,
          city: state.city,
          street: state.street,
          zipcode: state.zipcode,
          countryId: state.countryId,
        },
      };

      await register(params);
      const appointmentId = route.params.appointmentId as string;

      router.push(localePath({ name: 'presentation-appointmentId', params: { appointmentId } }));
    } catch (e) {
      registerErrorMsg.value = getErrorMessages(e as ClientApiError) as string;
    } finally {
      isLoading.value = false;
    }
  };

  const onChange = () => {
    registerErrorMsg.value = '';
  };

  const goToLogin = () => {
    const appointmentId = route.params.appointmentId as string;

    router.push(
      localePath({ name: 'presentation-appointmentId-login', params: { appointmentId } }),
    );
  };
</script>
<template>
  <ClientOnly>
    <div
      class="min-h-100vh my-5.5 container mx-auto flex w-[32.5rem] flex-col items-center justify-center px-3"
    >
      <form
        class="flex w-full flex-col gap-6"
        autocomplete="on"
        @change="onChange"
        @submit="createAndJoin"
      >
        <div>
          <h2 class="font-bold">{{ $t('createAccount') }}</h2>
          <span class="text-darkgray-600 mt-2">{{ $t('createAccountForm.description') }}</span>
        </div>

        <SwSelect
          v-model="state.salutationId"
          key-field="id"
          label-field="name"
          :options="salutations"
          :errors="$v.salutationId.$errors"
          size="large"
          :placeholder="$t('notSpecified')"
        >
          <template #label>
            <ListboxLabel class="text-information-dark mb-1.5 block text-sm/4 font-medium">
              {{ $t('salutation') }}
            </ListboxLabel>
          </template>
        </SwSelect>

        <div class="flex justify-between gap-6">
          <SwTextField
            v-model="state.firstName"
            size="large"
            :placeholder="$t('createAccountForm.firstNamePlaceholder')"
            name="firstName"
            type="text"
            :errors="$v.firstName.$errors"
            :label="$t('firstName')"
            class="flex-1"
          />

          <SwTextField
            v-model="state.lastName"
            size="large"
            :placeholder="$t('createAccountForm.lastNamePlaceholder')"
            name="lastName"
            type="text"
            :errors="$v.lastName.$errors"
            :label="$t('lastName')"
            class="flex-1"
          />
        </div>

        <SwTextField
          id="email"
          v-model="state.email"
          size="large"
          :placeholder="$t('createAccountForm.emailPlaceholder')"
          name="email"
          type="email"
          :errors="$v.email.$errors"
          :label="$t('email')"
        />

        <SwTextField
          id="password"
          v-model="state.password"
          size="large"
          :placeholder="$t('createAccountForm.passwordPlaceholder')"
          name="password"
          type="password"
          :errors="$v.password.$errors"
          :label="$t('password')"
        />

        <SwTextField
          v-model="state.street"
          size="large"
          :placeholder="$t('createAccountForm.streetPlaceholder')"
          name="street"
          type="text"
          :errors="$v.street.$errors"
          :label="$t('streetAndNumber')"
        />

        <div class="flex justify-between gap-6">
          <SwTextField
            v-model="state.zipcode"
            size="large"
            :placeholder="$t('createAccountForm.postalCodePlaceholder')"
            name="postalCode"
            type="text"
            :errors="$v.zipcode.$errors"
            :label="$t('postalCode')"
            class="flex-1"
          />

          <SwTextField
            v-model="state.city"
            size="large"
            :placeholder="$t('createAccountForm.cityPlaceholder')"
            name="city"
            type="text"
            :errors="$v.city.$errors"
            :label="$t('city')"
            class="flex-1"
          />
        </div>

        <SwSelect
          v-model="state.countryId"
          key-field="id"
          label-field="name"
          :options="countries"
          :errors="$v.countryId.$errors"
          size="large"
          :placeholder="$t('createAccountForm.chooseCountry')"
        >
          <template #label>
            <ListboxLabel class="text-information-dark mb-1.5 block text-sm/4 font-medium">
              {{ $t('country') }}
            </ListboxLabel>
          </template>
        </SwSelect>

        <SwCheckbox v-if="mediaShouldBeUsed" v-model="state.agree" :errors="$v.agree.$errors">
          <template #label>
            <i18n-t keypath="agreeTermsDailyPrivacyPolicy" :tag="false">
              <template #privacyPolicy>
                <SwLink :to="DAILY_PRIVACY_POLICY_LINK" target="_blank">
                  {{ $t('privacyPolicy') }}
                </SwLink>
              </template>
            </i18n-t>
          </template>
        </SwCheckbox>

        <SwBanner v-if="registerErrorMsg" variant="error" :show-close-btn="false">
          {{ $t(registerErrorMsg) }}
        </SwBanner>

        <div class="pt-2">
          <SwButton type="submit" :loading="isLoading" variant="primary">
            {{ $t('createAccountForm.createAndJoin') }}
          </SwButton>
        </div>
      </form>

      <div class="border-border mt-8 flex w-full justify-center gap-2 border-t pt-5">
        <span class="text-sm font-medium">{{ $t('alreadyHaveAccount') }}</span>
        <button class="text-(primary sm) font-medium" @click="goToLogin">
          {{ $t('login') }}
        </button>
      </div>
    </div>
  </ClientOnly>
</template>
